<?php
// Uso de Interface IteratorAggregate archivo file104b.php

// uso de foreach sobre propiedades pblicas

print "<B>Uso de interface IteratorAggregate (archivo file104b.php)</U></B><BR><BR>";

class MiClase implements IteratorAggregate
{
    public $pasesPublic = array();
    
    // este array no lo listar porque es private
    private $pasesPrivate = array();
    
    public $prop1 = "mi propiedad pblica 1";
    public $prop2 = "propiedad pblica 2";
    public $prop3 = "propiedad pblica 3";
    
    // a esta propiedad no la listar
    protected $prop4 = "propiedad protected 2";
    
    // implementa la interface IteratorAggregate:
    // debe implementar mtodo siguiente:
    // IteratorAggregate::getIterator()
   
    public function __construct($matriz)
    {
        // asigna los valores a la matriz privada
        if (is_array($matriz)) {
            $this->pasesPublic = $matriz;
            $this->pasesPrivate = $matriz;
        }
    }

    public function getIterator() {
       $var =  new ArrayIterator($this);
       // la ventaja de este enfoque respecto
       // al foreach simple sin Iterator
       // es que aqu podemos manipular los valores
       // mediante los mtodos del objeto ArrayIterator
       // por ejemplo:  
       //  $var->offsetSet();
       // $var->offUnset();
       return $var;
    } 

   
}

$matriz = array("Francia" => "Pars", "Italia" => "Roma", "Uruguay" => "Montevideo");
$obj = new MiClase($matriz);

foreach ($obj as $clave => $valor) {
    print "<BR>clave $clave => valor $valor <BR>";
    if (is_array($valor))
        print_r ($valor);
}

 

?> 
